SystemOrganization addCategory: #MethodWrappers!
SystemOrganization addCategory: #'MethodWrappers-Dummies'!
SystemOrganization addCategory: #'MethodWrappers-Tests'!

!Class methodsFor: '*MethodWrappers' stamp: 'mga 1/7/2004 18:39'!
unwrapAllMethods
	^ObjectAsMethodWrapper uninstallClass: self! !

!Class methodsFor: '*MethodWrappers' stamp: 'mga 1/7/2004 17:37'!
wrapAllMethods
	^ObjectAsOneTimeMethodWrapper installOnClass: self! !

!Class methodsFor: '*MethodWrappers' stamp: 'mga 1/7/2004 18:17'!
wrappedMethods
	|someMethods|
	someMethods:= Set new.
	someMethods addAll: (self methodDictionary values select: [:e | e isKindOf: ObjectAsMethodWrapper ]).
	someMethods addAll: (self class  methodDictionary values select: [:e | e isKindOf: ObjectAsMethodWrapper ]).
	^someMethods! !

!CompiledMethod methodsFor: '*MethodWrappers' stamp: 'sd 4/7/2009 22:02'!
uninstall
	"does nothing but now a compiled method is a bit more polymorphic with anObjectAsWrapper"
	! !

TestCase subclass: #ObjectAsOneTimeMethodWrapperTest
	instanceVariableNames: 'preExecuted postExecuted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodWrappers-Tests'!

!ObjectAsOneTimeMethodWrapperTest methodsFor: 'accessing' stamp: 'mga 1/7/2004 14:28'!
postExecuted
	"Answer the value of postExecuted"

	^ postExecuted! !

!ObjectAsOneTimeMethodWrapperTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/23/2010 16:32'!
postExecuted: anObject
	"Set the value of postExecuted"

	postExecuted := anObject! !

!ObjectAsOneTimeMethodWrapperTest methodsFor: 'accessing' stamp: 'mga 1/7/2004 14:28'!
preExecuted
	"Answer the value of preExecuted"

	^ preExecuted! !

!ObjectAsOneTimeMethodWrapperTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/23/2010 16:32'!
preExecuted: anObject
	"Set the value of preExecuted"

	preExecuted := anObject! !

!ObjectAsOneTimeMethodWrapperTest methodsFor: 'running' stamp: 'mga 1/7/2004 16:10'!
testInstallOn
	"self run: #testInstallOn"
	|aWrapper|
	aWrapper := ObjectAsOneTimeMethodWrapper installOn: ObjectAsMethodWrapperDummy selector: #foo.
	aWrapper preblock: [:aSel :someArgs :aRec | self preExecuted:true].
	aWrapper postblock: [:aSel :someArgs :aRec | self postExecuted:true].
	[self assert: (ObjectAsMethodWrapperDummy new foo = 1).
	self assert: aWrapper executed.
	self assert: preExecuted.
	self assert: postExecuted] ensure: [aWrapper uninstall].
	^aWrapper! !

!ObjectAsOneTimeMethodWrapperTest methodsFor: 'running' stamp: 'MarianoMartinezPeck 3/23/2010 16:28'!
testInstallOnClassCategory
	"self run: #testInstallOnClassCategory"
	| someWrappers |
	someWrappers := ObjectAsOneTimeMethodWrapper installOnClassCategory: 'MethodWrappers-Dummies'.
	[self assert: (ObjectAsMethodWrapperDummy new foo = 1).
	self assert: (someWrappers anySatisfy: [:e | e executed not]).
	self assert: (ObjectAsMethodWrapperDummy new bar = 2).
	self assert: (someWrappers allSatisfy: [:e | e executed])] ensure: [someWrappers do: [:e | e uninstall]].
	^someWrappers! !

Object subclass: #ObjectAsMethodWrapper
	instanceVariableNames: 'oldMethod preblock postblock reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodWrappers'!

!ObjectAsMethodWrapper commentStamp: 'cyrille.delaunay 3/23/2009 11:24' prior: 0!
This class implements methodWrapper like behavior using the trick that the VM allows any object to be put in 
a method dictionary if it implements run:with:in:


Here is a way to install a methodWrapper.

((PackageInfo named: 'Morphic') classes gather: [ :each | 
	ObjectAsOneTimeMethodWrapper installOnClass: each ]) inspect

((PackageInfo named: 'Morphic') classes do: [:each|ObjectAsMethodWrapper uninstallClass: each ]) 


Possible improvements:
	- it is not clear that specifying pre and post action is better than a simple method as in the original MethodWrapper
	implementation. !

ObjectAsMethodWrapper subclass: #ObjectAsCountingTimeMethodWrapper
	instanceVariableNames: 'counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodWrappers'!

!ObjectAsCountingTimeMethodWrapper classSide methodsFor: 'examples' stamp: 'mga 3/25/2004 21:57'!
examplePixelValueAt
	self installOn: Form selector: #pixelValueAt:! !

!ObjectAsCountingTimeMethodWrapper methodsFor: 'testing' stamp: 'sd 4/7/2009 17:48'!
counter

	^ counter! !

!ObjectAsCountingTimeMethodWrapper methodsFor: 'testing' stamp: 'sd 4/7/2009 17:49'!
executed

	^ counter > 0 ! !

!ObjectAsCountingTimeMethodWrapper methodsFor: 'initialize' stamp: 'stephane.ducasse 3/9/2009 22:18'!
initialize
	super initialize.
	counter := 0.
	postblock := [:aSel :someArgs :aRec | counter := counter+1]! !

!ObjectAsMethodWrapper classSide methodsFor: 'instance creation' stamp: 'mga 1/7/2004 00:07'!
installOn: aClass selector: aSel
	^(self on: aClass selector: aSel) install;yourself! !

!ObjectAsMethodWrapper classSide methodsFor: 'instance creation' stamp: 'mga 1/7/2004 18:12'!
installOnClass: aClass
	|someWrappers|
	someWrappers:=OrderedCollection new.
	aClass selectors do: [:aSymbol | someWrappers add: (self installOn: aClass selector: aSymbol)].
	aClass class selectors do: [:aSymbol | someWrappers add: (self installOn: aClass class selector: aSymbol)].
	^someWrappers! !

!ObjectAsMethodWrapper classSide methodsFor: 'instance creation' stamp: 'mga 1/7/2004 17:35'!
installOnClassCategory: aString
	|someWrappers|
	someWrappers:= OrderedCollection new.
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		someWrappers addAll: (self installOnClass: (Smalltalk classNamed: aClassName)).
		].
	^someWrappers
	! !

!ObjectAsMethodWrapper classSide methodsFor: 'instance creation' stamp: 'Mariano 3/22/2010 15:49'!
on: aMethodReference
	^self new initializeFor: aMethodReference ! !

!ObjectAsMethodWrapper classSide methodsFor: 'instance creation' stamp: 'dgg 1/26/2012 14:15'!
on: aClass selector: aSelector
	^self on: (RGMethodDefinition class: aClass selector: aSelector)! !

!ObjectAsMethodWrapper classSide methodsFor: 'instance creation' stamp: 'mga 1/7/2004 17:50'!
uninstallClass: aClass
	aClass methodDict values do: [:e | (e isKindOf: self) ifTrue: [e uninstall]].
	aClass class methodDict values do: [:e | (e isKindOf: self) ifTrue: [e uninstall]].! !

!ObjectAsMethodWrapper classSide methodsFor: 'instance creation' stamp: 'mga 1/7/2004 18:52'!
uninstallClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!ObjectAsMethodWrapper classSide methodsFor: 'instance creation' stamp: 'mga 1/7/2004 18:52'!
uninstallOnClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!ObjectAsMethodWrapper methodsFor: 'testing' stamp: 'mga 1/7/2004 19:24'!
doesNotUnderstand: aMessage

	^ oldMethod isNil
		ifTrue: [super doesNotUnderstand: aMessage]
		ifFalse: [oldMethod perform: aMessage selector withArguments: aMessage arguments]! !

!ObjectAsMethodWrapper methodsFor: 'action' stamp: 'MarianoMartinezPeck 3/16/2011 10:55'!
flushCache
	self selector flushCache ! !

!ObjectAsMethodWrapper methodsFor: 'initializing' stamp: 'stephane.ducasse 3/9/2009 22:16'!
initialize
	preblock := [:aSel :someArgs :aRec | nil].
	postblock := [:aSel :someArgs :aRec | nil].! !

!ObjectAsMethodWrapper methodsFor: 'initializing' stamp: 'Mariano 3/22/2010 16:00'!
initializeFor: aMethodReference 
	reference := aMethodReference.! !

!ObjectAsMethodWrapper methodsFor: 'action' stamp: 'MarianoMartinezPeck 3/22/2010 17:46'!
install
	[oldMethod := self wrappedClass lookupSelector: self selector.
	oldMethod isKindOf: self class] whileTrue: [oldMethod uninstall].
	"self wrappedClass addSelector: self selector withMethod: self" 
	self wrappedClass methodDict at: self selector put: self! !

!ObjectAsMethodWrapper methodsFor: 'accessing' stamp: 'mga 1/7/2004 14:28'!
oldMethod
	"Answer the value of oldMethod"

	^ oldMethod! !

!ObjectAsMethodWrapper methodsFor: 'accessing' stamp: 'stephane.ducasse 3/9/2009 22:16'!
oldMethod: anObject
	"Set the value of oldMethod"

	oldMethod := anObject! !

!ObjectAsMethodWrapper methodsFor: 'accessing' stamp: 'mga 1/7/2004 14:28'!
postblock
	"Answer the value of postblock"

	^ postblock! !

!ObjectAsMethodWrapper methodsFor: 'accessing' stamp: 'stephane.ducasse 3/9/2009 22:16'!
postblock: anObject
	"Set the value of postblock"

	postblock := anObject! !

!ObjectAsMethodWrapper methodsFor: 'accessing' stamp: 'mga 1/7/2004 14:28'!
preblock
	"Answer the value of preblock"

	^ preblock! !

!ObjectAsMethodWrapper methodsFor: 'accessing' stamp: 'stephane.ducasse 3/9/2009 22:16'!
preblock: anObject
	"Set the value of preblock"

	preblock := anObject! !

!ObjectAsMethodWrapper methodsFor: 'accessing' stamp: 'Mariano 3/22/2010 15:51'!
reference
	^ reference ! !

!ObjectAsMethodWrapper methodsFor: 'action' stamp: 'stephane.ducasse 3/9/2009 22:17'!
run: aSelector with: arguments in: aReceiver

	| aResult |
	preblock value: aSelector value: arguments value: aReceiver.
	aResult := oldMethod valueWithReceiver: aReceiver arguments: arguments.
	postblock value: aSelector value: arguments value: aReceiver.
	^aResult
	! !

!ObjectAsMethodWrapper methodsFor: 'accessing' stamp: 'Mariano 3/22/2010 15:55'!
selector
	"Answer the value of selector"

	^ reference selector! !

!ObjectAsMethodWrapper methodsFor: 'action' stamp: 'MarianoMartinezPeck 3/22/2010 17:46'!
uninstall

	oldMethod isNil ifTrue: [^self].
	"self wrappedClass removeSelectorSilently: self selector.
	self wrappedClass addSelector: self selector withMethod: oldMethod.
	"
	self wrappedClass methodDict at: self selector put: oldMethod  

! !

!ObjectAsMethodWrapper methodsFor: 'accessing' stamp: 'dgg 1/26/2012 15:14'!
wrappedClass
	"Answer the value of wrappedClass"

	^ reference parent! !

ObjectAsMethodWrapper subclass: #ObjectAsOneTimeMethodWrapper
	instanceVariableNames: 'executed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodWrappers'!

!ObjectAsOneTimeMethodWrapper methodsFor: 'accessing' stamp: 'mga 1/7/2004 15:03'!
executed
	"Answer the value of executed"

	^ executed! !

!ObjectAsOneTimeMethodWrapper methodsFor: 'accessing' stamp: 'Mariano 3/22/2010 11:34'!
executed: anObject
	"Set the value of executed"

	executed := anObject! !

!ObjectAsOneTimeMethodWrapper methodsFor: 'initializing' stamp: 'stephane.ducasse 3/9/2009 22:19'!
initialize

	super initialize.
	executed := false! !

!ObjectAsOneTimeMethodWrapper methodsFor: 'action' stamp: 'stephane.ducasse 3/9/2009 22:19'!
run: aSelector with: arguments in: aReceiver

	| aRes |
	aRes := super run: aSelector with: arguments in: aReceiver.
	[self executed: true]
		ensure: [self uninstall].
	^aRes! !

ObjectAsMethodWrapper subclass: #TestCoverageMethodWrapper
	instanceVariableNames: 'hasRun'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodWrappers'!

!TestCoverageMethodWrapper methodsFor: 'as yet unclassified' stamp: 'Mariano 3/22/2010 15:04'!
hasRun
	^ hasRun ! !

!TestCoverageMethodWrapper methodsFor: 'as yet unclassified' stamp: 'Mariano 3/22/2010 15:16'!
initialize
	super initialize.
	hasRun := false.
	postblock := [:aSel :someArgs :aRec |
			hasRun := true. 
			self uninstall.
			].! !

Object subclass: #ObjectAsMethodWrapperDummy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodWrappers-Dummies'!

!ObjectAsMethodWrapperDummy methodsFor: 'as yet unclassified' stamp: 'mga 1/7/2004 14:04'!
bar
	^ 2! !

!ObjectAsMethodWrapperDummy methodsFor: 'as yet unclassified' stamp: 'mga 1/7/2004 01:01'!
foo
	^ 1! !
